{$mode objfpc}{$h+}{$assertions on}{$R+}
uses Math, Types;

var
  f: array of String;
  w, h, start, finish: Integer;
  queue: array of TPoint;

function IsStable(x, y: Integer): Boolean;
begin
  Result :=
    (y = h - 1) or (f[y][x] = '.') or (f[y + 1][x] = 'O') or
    InRange(x, 2, w - 1) and (f[y][x - 1] <> '.') and (f[y][x + 1] <> '.');
end;

procedure Add(x, y: Integer);
begin
  if not InRange(x, 1, w) or not InRange(y, 0, h - 1) or IsStable(x, y) then exit;
  finish := (finish + 1) mod Length(queue);
  Assert(finish <> start);
  f[y][x] := '.';
  queue[finish] := Point(x, y);
end;

var
  x, y: Integer;
begin
  AssignFile(input, 'input.txt'); Reset(input);
  AssignFile(output, 'output.txt'); Rewrite(output);
  Readln(w, h);
  Assert(InRange(w, 1, 1000) and InRange(h, 1, 1000));
  SetLength(f, h);
  for y := 0 to h - 1 do
    Readln(f[y]);
  SetLength(queue, w * h * 2);
  start := 0;
  finish := 0;
  for y := 0 to h - 1 do
    for x := 1 to w do
      Add(x, y);
  while start <> finish do begin
    start := (start + 1) mod Length(queue);
    x := queue[start].x;
    y := queue[start].y;
    Add(x - 1, y);
    Add(x + 1, y);
    Add(x, y - 1);
  end;
  for y := 0 to h - 1 do
    Writeln(f[y]);
end.
